;******************************************************************************
; 稪 OS
;:   (aka Dios), zaikindenis@narod.ru asmfanat@narod.ru
; ᪥ dl - BIOS  㧮筮 ᪠
;******************************************************************************

macro align value { rb (value-1) - ($ + value-1) mod value }

Loader_Addr		equ 0600h	;  ஬ ९뢠  稪
SysLdr_Addr		equ 13000h	;  ஬ 㦠 SystemLoader
SecToLoad		equ 5		;- ᥪ஢  㧪  稪

; 稪 室  1- ᥪ ࠧ
use16
org 0
		jmp	word Start
LBASector	dd 39777003		;᮫  砫쭮 ᥪ
DriveNumber	db 80h			;BIOS  㧮筮 ᪠
	
Start:
;ந ॣ
	cli
	mov	ax,09000h
	mov	ss,ax
	mov	sp,0FFFFh
	sti
	push	cs
	pop	ds
     
;७ 㧮 ᥪ
	push	Loader_Addr/16
	pop	es
	mov	si,7C00h
	mov	di,0
	mov	cx,200h
	rep	movsb
	jmp	(Loader_Addr/16):FirstPart_Offs

FirstPart_Offs:

	push	cs
	pop	ds
	
;஢ 32- ࠧ來 
	push	sp
	pop	ax
	cmp	ax,sp
	jne	CPU_Err
	push	0
	pop	es
	mov	word [es:18h], CPU_Err		;⠭ ࠡ稪  ⨬ 
	mov	[es:1ah],cs
	cwde					;믮 32-  

;࠭ BIOS  㧮筮 ᪠
	mov	[DriveNumber],dl
	
;ந  ஫ ⪨ ᪮
	mov 	ah,0Dh
	int 	13h
	cmp	ah,0
	jne	Hdd_Err

;஢ BIOS  ७ ᪮ 㭪権
	mov	ah,41h
	mov	bx,055AAh
	int	13h
	cmp	bx,0AA55h
	jne	Ext_Err
	
;㧪 ⠫쭮  稪
	push	cs
	pop	es
	mov	di,200h
	mov	eax,[LBASector]
	inc	eax
	mov	cx,SecToLoad
	call	ReadSectors
	
;室   室騩  ᫥饬 ᥪ
Exec_SecondPart:
	mov	eax,[512]
	cmp	eax,11101982h	;஢ઠ  室饣  ᫥饬 ᥪ
	jne	Ldr_Err
	jmp	516

packet:			db 10h,0
packet_Sector_Count	dw 0
packet_Buffer_Offset 	dw 0
packet_Buffer_Segment	dw 0
packet_LBA		dd 0,0

Mes0 	db '[MLoader Error]: ',0
Mes1	db '32 bit processor required!',0
Mes2	db 'Disk error 0x00',0
Mes2_size=$-Mes2
Mes3 	db 'BIOS extension required!',0
Mes4 	db 'MLoader is bad!',0
Mes5	db 'Press eny key...',0
MesEOS	db  0Ah,0Dh,0

;ࠡ稪 訡:
CPU_Err:
	push	Mes1
	jmp	Error
Hdd_Err:
	mov	al,ah
	shr	al,4
	and	ax,111100001111b
	add	al,'0'
	add	ah,'0'
	cmp	al,'9'
	jb	al_b
	add	al,7
al_b:	cmp	ah,'9'
	jb	ah_b
	add	ah,7
ah_b:	mov	word [Mes2+Mes2_size-3],ax
	push	Mes2
	jmp	Error
Ext_Err:
	push	Mes3
	jmp	Error
Ldr_Err:
	push	Mes4
	jmp	Error
Error:
	mov	si,Mes0
	call	outstring
	pop	si
	call	outstring
	mov	si,MesEOS
	call	outstring
	mov	si,Mes5
	call	outstring
	mov	ah,0
	int	16h
	mov	si,MesEOS
	call	outstring
	int	19h

;******************************************************************************
;㭪 ⥭ ᥪ஢ (१ BIOS)
;es:di-buffer,eax-LBA sector,cx-sector count
;******************************************************************************
ReadSectors:
	pusha
	mov	[packet_Buffer_Segment],es
	mov	[packet_Buffer_Offset],di
	mov	[packet_LBA],eax
	mov	[packet_Sector_Count],cx
	mov	dl,[DriveNumber]
	mov	si,packet
	mov	ah,42h
	int	13h
	cmp	ah,0
	jne	Hdd_Err
	popa
	ret	

;******************************************************************************
;㭪 뢮 ASCIIZ ப 
;ds:si-ASCIIZ ப
;******************************************************************************
outstring:
	push	ax
	push	si
.OutStringLoop:
	lodsb
	or	al,al
	jz	.OutStringExit
	mov	ah,0eh
	int	10h
	jmp	.OutStringLoop
.OutStringExit:
	pop si
	pop ax
	ret

	align	510
	dw 	0AA55h


;******************************************************************************
; 稪 室   ᥪ஬:
;******************************************************************************

	dd 11101982h

	push	SysLdr_Addr/16
	pop	es
	mov	di,0
	mov	eax,0
	mov	cx,20
	call	ReadSectors

	jmp	$
